#include	<p18cxxx.h>
#include	"APP_EDF11_1_LCDModule.h"

#define LCM_INSTRUCTION	LATFbits.LATF5 = 0
#define LCM_DATA		LATFbits.LATF5 = 1

static unsigned int TRIS_Temporary = 0;
static unsigned int LAT_Temporary = 0;

void LCM_Delay( unsigned int Loop )
{
 	unsigned int i = 0 , j = 0;

	for( j = 0 ; j < Loop ; j ++ )
		for( i = 0 ; i < 200 ; i ++ ); 
}

unsigned char LCM_IsBusy( void )
{
 	unsigned int i = 0;

	for( i = 0 ; i < 50 ; i ++ );

/*
	unsigned char Temporary;

	PMPSetAddress( LCM_INSTRUCTION );
	Temporary = PMPMasterRead( );	// Dummy Read for trigger PMP active.

	while( PMMODEbits.BUSY );		// Wait PMP Complete.
									// No idea @@, See PMP FRM 13.4.2, Show below.

	Temporary = PMPMasterRead( );	// No idea @@, See PMP FRM 13.4.2, Show below.
	Temporary = PMPMasterRead( );

	return ( ( Temporary >> 7 ) & 0x01 ); 
*/
}

void IntLCM_WriteData( unsigned char Data )
{
	while( LCM_IsBusy( ) );
	LCM_DATA;
	PMDIN1 = Data;

/*
	while( LCM_IsBusy( ) );
	PMPSetAddress( LCM_DATA );
	PMPMasterWrite( Data );
*/
}

void IntLCM_WriteInstruction( unsigned char Instruction )
{
	while( LCM_IsBusy( ) );
	LCM_INSTRUCTION;
	PMDIN1 = Instruction;

/*
	while( LCM_IsBusy( ) );
	PMPSetAddress( LCM_INSTRUCTION );
	PMPMasterWrite( Instruction );
*/
}

void LCM_Init( void )
{
	TRIS_Temporary = TRISD;
	LAT_Temporary = LATD;

	// Inital PMP Module
	PMCONHbits.PMPEN = 1;
	PMCONHbits.PSIDL = 1;
	PMCONHbits.ADRMUX0 = 0;
	PMCONHbits.ADRMUX1 = 0;
	PMCONHbits.PTBEEN = 0;
	PMCONHbits.PTWREN = 1;
	PMCONHbits.PTRDEN = 1;

	PMCONLbits.CSF1 = 0;
	PMCONLbits.CSF0 = 0;
	PMCONLbits.ALP = 0;
	PMCONLbits.CS2P = 0;
	PMCONLbits.CS1P = 0;
	PMCONLbits.BEP = 0;
	PMCONLbits.WRSP = 1;
	PMCONLbits.RDSP = 1;

	PMMODEHbits.IRQM = 0;
	PMMODEHbits.INCM = 0;
	PMMODEHbits.MODE16 = 0;
	PMMODEHbits.MODE = 0x03;

	PMMODELbits.WAITE = 0x03;
	PMMODELbits.WAITM = 0x0f;
	PMMODELbits.WAITB = 0x03;

	PMEH = 0;
	PMEL = 0;

	TRISFbits.TRISF5 = 0;
	ANCON1bits.PCFG10 = 1;
	
/*
	PMPOpen( BIT_PMP_ON | BIT_SIDL_ON | BIT_ADDR_MUX_NONE | BIT_BE_OFF | BIT_RD_WR_ON | 
			 BIT_LATCH_LO | BIT_CS2_LO | BIT_CS1_LO | BIT_RD_WR_HI ,
			 BIT_IRQ_RW | BIT_INC_ADDR_NONE | BIT_DATA_8 | BIT_MODE_MASTER_1 |
			 BIT_WAITB_4_TCY | BIT_WAITM_15_TCY | BIT_WAITE_4_TCY ,
			 BIT_P0 , 0 ,
			 BIT_INT_OFF & BIT_INT_PRI_4 );
*/
			 
	IntLCM_WriteInstruction( 0x30 );
	LCM_Delay( 25 );

	IntLCM_WriteInstruction( 0x30 );
	LCM_Delay( 1 );

	IntLCM_WriteInstruction( 0x30 );
	LCM_Delay( 1 );

	IntLCM_WriteInstruction( Disp_2Line_8Bit_5x8Dots );
	LCM_Delay( 1 );

	IntLCM_WriteInstruction( Disp_Off );
	LCM_Delay( 1 );

	IntLCM_WriteInstruction( Disp_Clear );
	LCM_Delay( 10 );

	IntLCM_WriteInstruction( Disp_Entry_Inc );
	LCM_Delay( 1 );

	IntLCM_WriteInstruction( Disp_On );
	LCM_Delay( 1 );

}

void LCM_ReInit( void )
{
	TRIS_Temporary = TRISD;
	LAT_Temporary = LATD;
	PMCONHbits.PMPEN = 1;
}

void LCM_UnInit( void )
{
	PMCONHbits.PMPEN = 0;
	TRISD = TRIS_Temporary;
	LATD = LAT_Temporary;
}

void LCM_SetCursor( unsigned char X, unsigned char Y )
{
	IntLCM_WriteInstruction( ( 0x80 + ( Y * 0x40 ) + X ) );
}

void LCM_PutASCII(unsigned char Ascii )
{
	IntLCM_WriteData( Ascii );
}

void LCM_PutHex(unsigned char Hex )
{
	unsigned char Temporary;

	Temporary = ( Hex >> 4 ) & 0x0f ;

	if ( Temporary > 9 ) 
		Temporary += 0x37;
    else
		Temporary += '0';

	IntLCM_WriteData( Temporary );

	Temporary = Hex & 0x0f;
	if ( Temporary > 9 )
		Temporary += 0x37;
    else Temporary += '0';
		IntLCM_WriteData( Temporary );
}

void LCM_PutROMString( rom unsigned char *String )
{
	while ( *String != 0x00 )
		IntLCM_WriteData( *String++ );
}

void LCM_PutRAMString( unsigned char *String )
{
	while ( *String != 0x00 )
		IntLCM_WriteData( *String++ );
}

static unsigned char Disable_Zero = 1;

unsigned char LCM_BCD_Regulate( unsigned char BCD )
{
		if ( BCD == 0 ) 
		{
			if ( Disable_Zero == 1 ) 
				return ' ';
			else
				return '0';
		}

		else 
		{
			Disable_Zero = 0;
			return ( BCD += '0' );
		}		
}

void LCM_PutNumber( unsigned int Number , unsigned char Digit )
{
	unsigned char Temporary;
	Disable_Zero = 1;

	switch ( Digit )
	{
		default:
		case 4:
			Temporary = LCM_BCD_Regulate( ( Number % 10000 ) / 1000 );
			IntLCM_WriteData( Temporary );

		case 3:
			Temporary = LCM_BCD_Regulate( ( Number % 1000 ) / 100 );
			IntLCM_WriteData( Temporary );

		case 2:
			Temporary = LCM_BCD_Regulate( ( Number % 100 ) / 10 );
			IntLCM_WriteData( Temporary );

		case 1:
			Disable_Zero = 0;
			Temporary = LCM_BCD_Regulate( Number % 10 );
			IntLCM_WriteData( Temporary );
	}
}
